#ifndef __TIMER_H__
#define __TIMER_H__
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#define  T0_INT   1
//#define  T1_INT   1
//#define  T2_INT   1
#define  T2_CAP   1
/******************* CH549 Timer0 ************************/
//bTMR_CLKͬʱӰTimer0&1&2,ʹʱҪע (ʱʹñ׼ʱ)
#define mTimer0Clk12DivFsys( ) (T2MOD &= ~bT0_CLK)                          //ʱ,ʱ=Fsys/12 T0׼ʱ
#define mTimer0ClkFsys( )      (T2MOD |= bTMR_CLK | bT0_CLK)                //ʱ,ʱ=Fsys
#define mTimer0Clk4DivFsys( )  (T2MOD &= ~bTMR_CLK;T2MOD |=  bT0_CLK)       //ʱ,ʱ=Fsys/4ʱͬDEBUG.CmInitSTDIO
#define mTimer0CountClk( )     (TMOD |= bT0_CT)                             //ѡڼģʽT0ţP34½Ч
#define mTimer0RunCTL( SS )    (TR0 = SS ? START : STOP)                    //CH549 Timer0 ʼ(SS=1)/(SS=0)
/***** CH549 Timer1(DEBUG.CmInitSTDIOʹT1ģʽ2) *****/
#define mTimer1Clk12DivFsys( ) (T2MOD &= ~bT1_CLK)                          //ʱ,ʱ=Fsys/12  T1׼ʱ
#define mTimer1ClkFsys( )      (T2MOD |= bTMR_CLK | bT1_CLK)                //ʱ,ʱ=Fsys
#define mTimer1Clk4DivFsys( )  (T2MOD &= ~bTMR_CLK;T2MOD |=  bT1_CLK)       //ʱ,ʱ=Fsys/4
#define mTimer1CountClk( )     (TMOD |= bT1_CT)                             //ѡڼģʽT1ţP35½Ч
#define mTimer1RunCTL( SS )    (TR1 = SS ? START : STOP)                    //CH549 Timer1 ʼ(SS=1)/(SS=0)
/******************* CH549 Timer2 ************************/
#define mTimer2Clk12DivFsys( ) {T2MOD &= ~ bT2_CLK;C_T2 = 0;}                  //ʱ,ʱ=Fsys/12 T2׼ʱ
#define mTimer2ClkFsys( )      {T2MOD |= (bTMR_CLK | bT2_CLK);C_T2=0;}         //ʱ,ʱ=Fsys
#define mTimer2Clk4DivFsys( )  {T2MOD &= ~bTMR_CLK;T2MOD |=  bT2_CLK;C_T2 = 0;}//ʱ,ʱ=Fsys/4ʱͬDEBUG.CmInitSTDIO
#define mTimer2CountClk( )     {C_T2 = 1;}                                     //ѡڼģʽT2ţP10½Ч
#define mTimer2RunCTL( SS )    {TR2 = SS ? START : STOP;}                    //CH549 Timer2 ʼ(SS=1)/(SS=0)
#define mTimer2OutCTL( )       (T2MOD |= T2OE)                               //T2  ƵTF2/2   
#define CAP1Alter( )           (PIN_FUNC |= bT2_PIN_X;)                      //CAP1P10 ӳ䵽P14
#define CAP2Alter( )           (PIN_FUNC |= bT2EX_PIN_X;)                    //CAP2P11 ӳRST
/*******************************************************************************
* Function Name  : mTimer_x_ModInit(UINT8 x ,UINT8 mode)
* Description    : CH549ʱxģʽ
* Input          : UINT8 mode,Timerģʽѡ
                   0ģʽ013λʱTLnĸ3λЧ
                   1ģʽ116λʱ
                   2ģʽ28λԶװʱ
                   3ģʽ38λʱ  Timer0
                   3ģʽ3Timer1ֹͣ
                   UINT8 x ʱ  0 1 2
* Output         : None
* Return         : ɹ  SUCCESS
                   ʧ  FAIL
*******************************************************************************/
UINT8 mTimer_x_ModInit(UINT8 x ,UINT8 mode);
/*******************************************************************************
* Function Name  : mTimer_x_SetData(UINT8 x,UINT16 dat)
* Description    : CH549Timer
* Input          : UINT16 dat;ʱֵ
                   UINT8 x ʱ  0 1 2
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer_x_SetData(UINT8 x,UINT16 dat);
/*******************************************************************************
* Function Name  : CAP2Init(UINT8 mode)
* Description    : CH549ʱ2 T2EXŲ׽ܳʼCAP2 P11
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP2Init(UINT8 mode);
/*******************************************************************************
* Function Name  : CAP1Init(UINT8 mode)
* Description    : CH549ʱ2 T2Ų׽ܳʼT2(CAP1 P10)
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP1Init(UINT8 mode);
/*******************************************************************************
* Function Name  : CAP0Init(UINT8 mode)
* Description    : CH549ʱ2 CAP0Ų׽ܳʼ(CAP0 P36)
                   UINT8 mode,ز׽ģʽѡ
                   0:T2ex½صһ½
                   1:T2ex֮
                   3:T2exصһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CAP0Init(UINT8 mode);
#endif
