/********************************** (C) COPYRIGHT *******************************
* File Name          : UART.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/09
* Description        : CH549 ڳʼ
*******************************************************************************/
#include ".\UART\UART.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : CH549UART1Init
* Description    : UART1ʼ,Ĭ P26 P27
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART1Init()
{
    SCON1 &= ~bU1SM0;                            //ѡ8λͨѶ
    SCON1 |= bU1SMOD;                            //ģʽ
    SCON1 |= bU1REN;                             //ʹܽ
    SBAUD1 = 0 - FREQ_SYS/16/UART1_BUAD;         //
    SIF1 = bU1TI;                                //շɱ־
#ifdef UART1_INTERRUPT                           //жʹ
    IE_UART1 = 1;
    EA = 1;
#endif
}
/*******************************************************************************
* Function Name  : CH549UART1Alter()
* Description    : CH5491ӳ,ӳ䵽 P16 P17
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART1Alter()
{
    P1_MOD_OC |= (3<<6);                                                   //׼˫ģʽ
    P1_DIR_PU |= (3<<6);
    PIN_FUNC |= bUART1_PIN_X;                                              //Ÿù
}
/*******************************************************************************
* Function Name  : CH549UART1RcvByte()
* Description    : CH549UART1һֽ
* Input          : None
* Output         : None
* Return         : SBUF
*******************************************************************************/
UINT8  CH549UART1RcvByte( )
{
    while((SIF1&bU1RI) == 0)
    {
        ;    //ѯ
    }
    SIF1 = bU1RI;                                                          //ж
    return SBUF1;
}
/*******************************************************************************
* Function Name  : CH549UART1SendByte(UINT8 SendDat)
* Description    : CH549UART1һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART1SendByte(UINT8 SendDat)
{
    SBUF1 = SendDat;
    while((SIF1&bU1TI) == 0)
    {
        ;    //ѯȴ
    }
    SIF1 = bU1TI;                                                          //ж
}
#ifdef UART1_INTERRUPT
/*******************************************************************************
* Function Name  : UART1Interrupt(void)
* Description    : UART1 жϷ
*******************************************************************************/
void UART1Interrupt( void ) interrupt INT_NO_UART1 using 1                //1жϷ,ʹüĴ1
{
    UINT8 dat;
    if(SIF1&bU1RI)
    {
        SIF1 = bU1RI;                                                     //ж
        dat = SBUF1;
        CH549UART1SendByte(dat);
    }
}
#endif
/*******************************************************************************
* Function Name  : CH549UART2Init
* Description    : UART2ʼ,Ĭ P04 P05
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART2Init()
{
    SCON2 &= ~bU2SM0;                            //ѡ8λͨѶ
    SCON2 |= bU2SMOD;                            //ģʽ
    SCON2 |= bU2REN;                             //ʹܽ
    SBAUD2 = 0 - FREQ_SYS/16/UART2_BUAD;         //
    SIF2 = bU2TI;                                //շɱ־
#ifdef UART2_INTERRUPT                           //жʹ
    SCON2 |= bU2IE;                              //UART2жϣرADCж
    IE_UART2 = 1;
    EA = 1;
#endif
}
/*******************************************************************************
* Function Name  : CH549UART2RcvByte()
* Description    : CH549UART2һֽ
* Input          : None
* Output         : None
* Return         : SBUF
*******************************************************************************/
UINT8 CH549UART2RcvByte( )
{
    while((SIF2&bU2RI) == 0)
    {
        ;    //ѯ
    }
    SIF2 = bU2RI;                                                          //ж
    return SBUF2;
}
/*******************************************************************************
* Function Name  : CH549UART2SendByte(UINT8 SendDat)
* Description    : CH549UART2һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART2SendByte(UINT8 SendDat)
{
    SBUF2 = SendDat;
    while((SIF2&bU2TI) == 0)
    {
        ;    //ѯȴ
    }
    SIF2 = bU2TI;                                                          //ж
}
#ifdef UART2_INTERRUPT
/*******************************************************************************
* Function Name  : UART1Interrupt(void)
* Description    : UART1 жϷ
*******************************************************************************/
void UART2Interrupt( void ) interrupt INT_NO_UART2 using 1                //2жϷ,ʹüĴ1
{
    UINT8 dat;
    if(SIF2&bU2RI)
    {
        SIF2 = bU2RI;                                                     //ж
        dat = SBUF2;
        CH549UART2SendByte(dat);
    }
}
#endif
/*******************************************************************************
* Function Name  : CH549UART3Init
* Description    : UART3ʼ,Ĭ P06 P07
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART3Init()
{
    SCON3 &= ~bU3SM0;                            //ѡ8λͨѶ
    SCON3 |= bU3SMOD;                            //ģʽ
    SCON3 |= bU3REN;                             //ʹܽ
    SBAUD3 = 0 - FREQ_SYS/16/UART3_BUAD;         //
    SIF3 = bU3TI;                                //շɱ־
#ifdef UART3_INTERRUPT                           //жʹ
    SCON3 |= bU3IE;                              //UART3жϣرPWMж
    IE_UART3 = 1;
    EA = 1;
#endif
}
/*******************************************************************************
* Function Name  : CH549UART3RcvByte()
* Description    : CH549UART3һֽ
* Input          : None
* Output         : None
* Return         : SBUF
*******************************************************************************/
UINT8 CH549UART3RcvByte( )
{
    while((SIF3&bU3RI) == 0)
    {
        ;    //ѯ
    }
    SIF3 = bU3RI;                                                          //ж
    return SBUF3;
}
/*******************************************************************************
* Function Name  : CH549UART3SendByte(UINT8 SendDat)
* Description    : CH549UART3һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH549UART3SendByte(UINT8 SendDat)
{
    SBUF3 = SendDat;
    while((SIF3&bU3TI) == 0)
    {
        ;    //ѯȴ
    }
    SIF3 = bU3TI;                                                          //ж
}
#ifdef UART3_INTERRUPT
/*******************************************************************************
* Function Name  : UART1Interrupt(void)
* Description    : UART1 жϷ
*******************************************************************************/
void UART3Interrupt( void ) interrupt INT_NO_UART3 using 1                //3жϷ,ʹüĴ1
{
    UINT8 dat;
    if(SIF3&bU3RI)
    {
        SIF3 = bU3RI;                                                     //ж
        dat = SBUF3;
        CH549UART3SendByte(dat);
    }
}
#endif
