/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2019/07/22
* Description        : CH549 16ͨʾ
*                      CH0~CH15 ֱӦ P1.0~P1.7  P0.0~P0.7
                       עDEBUG.C
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include ".\TouchKey\TouchKey.H"
#pragma  NOAREGS
UINT16 PowerValue[16];                                                         //津ϵδֵ
volatile UINT16 Press_Flag = 0;                                                //±־λ
UINT8C CPW_Table[16] = { 30,30,30,30, 30,30,30,30,                             //йصĲֱӦÿ
                         30,30,30,30, 30,30,30,30,
                       };

/*******************************************************************************
* Function Name  : ABS
* Description    : ֵľֵ
* Input          : a,b
* Output         : None
* Return         : ֵֵ
*******************************************************************************/
UINT16 ABS(UINT16 a,UINT16 b)
{
    if(a>b)
    {
        return (a-b);
    }
    else
    {
        return (b-a);
    }
}
/*******************************************************************************
* Function Name  : LED_Port_Init
* Description    : LEDųʼ,
*                  P22~P25
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void LED_Port_Init(void)
{
    P2 |= (0xF<<2);                                                          //ĬϨ
    P2_MOD_OC &= ~(0xF<<2);
    P2_DIR_PU |= (0xF<<2);
}
/*******************************************************************************
* Function Name  : LED_Control
* Description    : ƿ
* Input          : LEDx: 0~3 ֱӦP22~P25ĸLEDƣ
*                  status: 0:  1
* Output         : None
* Return         : None
*******************************************************************************/
void LED_Control(UINT8 LEDx,UINT8 status)
{
    if(LEDx>3)
    {
        return;
    }
    if(status)                                                                //
    {
        P2 &= ~(1<<(2+LEDx));
    }
    else                                                                      //Ϩ
    {
        P2 |= (1<<(2+LEDx));
    }
}
//
void main()
{
	UINT8 i = 100;
    UINT8 ch;
    UINT16 value;
    UINT16 err;                                                                //ģ仯ֵ
    memset(KeyBuf,0,sizeof(KeyBuf));	
    CfgFsys( );                                                                //CH549ʱѡ
    mDelaymS(20);
    mInitSTDIO( );                                                             //0ʼ
    printf("TouchKey demo start ...\n");
    LED_Port_Init();
    TouchKey_Init();
    Press_Flag = 0;                                                            //ް
    /* ȡֵ */
    for(ch = 8; ch!=12; ch++)
    {
        PowerValue[ch] = Default_TouchKey( ch,CPW_Table[ch] );
        printf(" Y%d ",PowerValue[ch] );
    }
    printf("\n");
    while(1)
    {
		while(i)                                                             //ʼֵʡ
		{
			 for(ch = 8; ch!=12; ch++)
			{
				TouchKeySelect( ch,CPW_Table[ch] );
				i--;
			}
		}
        /*  */
        for(ch = 8; ch!=12; ch++)
        {
            value = TouchKeySelect( ch,CPW_Table[ch] );
            err = ABS(PowerValue[ch],value);
            if( err > DOWM_THRESHOLD_VALUE )                                   //ֵֵΪ
            {
                if((Press_Flag & (1<<ch)) == 0)                                //˵ǵһΰ
                {
                    printf("ch %d pressed,value:%d\n",(UINT16)ch, value);
                    /* ƴ */
                    LED_Control(ch-8,1);
                }
                Press_Flag |= (1<<ch);
            }
            else if( err < UP_THRESHOLD_VALUE )                                //˵̧δ
            {
                if(Press_Flag & (1<<ch))                                       //̧
                {
                    Press_Flag &= ~(1<<ch);
                    printf("ch %d up,value:%d\n",(UINT16)ch, value);
                    /* ƴ */
                    LED_Control(ch-8,0);
                }
            }
        }
    }
}
